//==============================================================================//
//				DirectX9pėpCu Luna									//
//==============================================================================//
//																				//
//	ŐVł̒uĂURL														//
//																				//
//		TWINTAIL LOVERS.														//
//			http://www.twin-tail.jp/											//
//																				//
//	ⓙꏊ																//
//																				//
//		BBS																		//
//			TWINTAIL LOVERS.̌f											//
//																				//
// DirectX Library "Luna for DirectX 9.0c"										//
// Copyright (C) 2003-2005 t`												//
// All rights reserved.															//
//																				//
//==============================================================================//

/** @file
    @brief		ŎgpĂe^`sĂ܂
    @author		t`
    @since		2003.07.01
*/

#ifndef ___LUNABASE_H___
#define ___LUNABASE_H___


//================================================================================
// WARNING
//================================================================================
#ifndef __GCC__

#pragma warning ( disable: 4127 )		// 萔̏
#pragma warning ( disable: 4100 )		// QƂ̕ϐ
#pragma warning ( disable: 4514 )		// QƂ̃CC֐
#pragma warning ( disable: 4711 )		// CCWJ
#pragma warning ( disable: 4201 )		// \̊g[jO

#pragma inline_depth ( 255 )
#pragma inline_recursion ( on )

#endif

//=============================================================================
// FOR MSVC6.0
//=============================================================================
#if (_MSC_VER == 1200)
#if 0 //dF
	typedef long			LONG_PTR;
	typedef unsigned long	DWORD_PTR;
	typedef void (__stdcall *PAPCFUNC)( DWORD_PTR dwParam );
#endif
#endif


//================================================================================
// FOR GCC	
//================================================================================
#ifdef __GCC__
	#undef __MSVCRT__
	#define __MSVCRT__

	#define MAX_PATH 260

	int stricmp( const char *p1, const char *p2 );
#endif


//================================================================================
// INCLUDE
//================================================================================
/*#undef DIRECTINPUT_VERSION
#define DIRECTINPUT_VERSION		(0x0800)			///< DirectInputo[W`

#undef _WIN32_WINNT
#define _WIN32_WINNT			(0x0400)			///< Fiberp
*/
#undef WIN32_LEAN_AND_MEAN
#define WIN32_LEAN_AND_MEAN							///< svȃwb_̎Qƍ폜

#undef STRICT
#define STRICT										///< \̊g錾

#define __MT__

#ifdef __GCC__
#undef __MSVCRT__
#define __MSVCRT__
#endif

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <mbstring.h>
#include <tchar.h>
#include <wchar.h>
#include <windows.h>
#include <process.h>
#include "dx_select.hpp"
	/*
#include <winsock2.h>
#include <shellapi.h>

#include <commdlg.h>
#include <shlobj.h>
#include <imm.h>
#include <vfw.h>
#include <objbase.h>
#include <basetsd.h>

#include <d3dx9xof.h>
#include <d3d9.h>
#include <d3dx9.h>
#include <dsound.h>
#include <dinput.h>
#include <dmusicc.h>
#include <dmusici.h>
#include <dshow.h>
#include <mmstream.h>
#include <amstream.h>
#include <ddstream.h>

#ifndef __GCC__
#include <winnls32.h>
#endif

#undef NULL
#define NULL		(0x00000000)
*/
namespace lunadxmath{

//================================================================================
// TYPEDEF
//================================================================================
typedef char					Sint8;								///< signed char ^̕ʒ`
typedef short					Sint16;								///< signed short ^̕ʒ`
typedef long					Sint32;								///< signed long ^̕ʒ`
typedef __int64					Sint64;								///< signed __int64 ^̕ʒ`
typedef unsigned char			Uint8;								///< unsigned char ^̕ʒ`
typedef unsigned short			Uint16;								///< unsigned short ^̕ʒ`
typedef unsigned long			Uint32;								///< unsigned long ^̕ʒ`
typedef unsigned __int64		Uint64;								///< unsigned __int64 ^̕ʒ`
typedef float					Float;								///< float ^̕ʒ`
typedef float					Float32;							///< float ^̕ʒ`
typedef double					Float64;							///< double ^̕ʒ`
typedef long double				Float80;							///< long double ^̕ʒ`


typedef bool (*PCALLBACKSOCKETPROC)( HWND hWnd, long Id );			///< \PbgpR[obN֐
typedef void (WINAPI *PFIBERPROC)( void *pParameter );				///< }CNXbhpR[obN֐
typedef bool (*PMICROTHREADPROC)( void *pParameter );				///< XbhpR[obN֐
//typedef IDirect3D9 * (WINAPI *PDIRECT3DCREATE9)( unsigned int );	///< Direct3DIuWFNg֐p


//================================================================================
// DEFINE
//================================================================================
static const Sint32 OPTION_DIRECT3D				= (1 <<  0);						///< DirectXGraphicsgpĉʕ`s
static const Sint32 OPTION_DIRECTINPUT			= (1 <<  1);						///< DirectInputgpăL[͂s
static const Sint32 OPTION_DIRECTSOUND			= (1 <<  2);						///< DirectSoundgpăTEhĐs
static const Sint32 OPTION_DIRECTMUSIC			= (1 <<  3);						///< DirectMusicgpăTEhĐs
static const Sint32 OPTION_DIRECTSHOW			= (1 <<  4);						///< DirectShowgpă[r[̍Đ
static const Sint32 OPTION_CDDA					= (1 <<  5);						///< MCIgpCDDAgp
static const Sint32 OPTION_FIBER				= (1 <<  6);						///< Fibergpă^XN


static const Sint32 FX_SEND_TRANSFORM			= (1 <<  0);
static const Sint32 FX_SEND_WORLDMATRIX			= (1 <<  1);
static const Sint32 FX_SEND_WORLDVIEWMATRIX		= (1 <<  2);
static const Sint32 FX_SEND_BONEDATA			= (1 <<  3);
static const Sint32 FX_SEND_LIGHTDATA			= (1 <<  4);
static const Sint32 FX_SEND_MATERIALDATA		= (1 <<  5);
static const Sint32 FX_SEND_SLIDE_UV			= (1 <<  6);
static const Sint32 FX_SEND_VERTEXEXTRUCT		= (1 <<  7);
static const Sint32 FX_SEND_MORPFWEIGHT			= (1 <<  8);
static const Sint32 FX_SEND_CAMERAPOS			= (1 <<  9);
static const Sint32 FX_SEND_TEXTURE				= (1 << 10);
static const Sint32 FX_SEND_FOGDATA				= (1 << 11);


//================================================================================
// CLASS TYPEDEF
//================================================================================
/*
#include "LunaVector2.h"
#include "LunaVector3.h"
#include "LunaMatrix.h"
#include "LunaQuaternion.h"
#include "LunaStyle.h"
*/
typedef class CVector2		LVECTOR2;							///< QcxNgNX
typedef class CVector3		LVECTOR3;							///< RcxNgNX
typedef class CMatrix		LMATRIX;							///< }gbNXNX
typedef class CQuaternion	LQUATERNION;						///< lNX
typedef class CPlane		LPLANE;								///< ʃNX
typedef class CStyle		LSTYLE;								///< pNX


//================================================================================
// DEFINE
//================================================================================
#define for						if ( false ) ; else for														///< forXR[v}N
#define ef						else if																		///< else if ȗp}N
#define F(V)					((Float)(V))																///< Float^ւ̃LXg}N
#define L(V)					((Sint32)(V))																	///< Sint32^ւ̃LXg}N

#define PI						(3.141592653589793238462643383279f)											///< 
#define PI2						(6.283185307179586476925286766559f)											///< 2
#define REV(V)					F(1.0f/F(V))																///< tZo}N

#define SAFE_RELEASE(V)			if ( (V) != NULL ) { (V)->Release(); (V) = NULL; }							///< COMS}N
#define SAFE_DELETE(V)			if ( (V) != NULL ) { delete (V); (V) = NULL; }								///< newS
#define SAFE_DELETES(V)			if ( (V) != NULL ) { delete [] (V); (V) = NULL; }							///< new[]S

#define MIN(N1,N2)				((N1 < N2) ? (N1) : (N2))													///< ŏl擾}N
#define MAX(N1,N2)				((N1 > N2) ? (N1) : (N2))													///< ől擾}N
#define SWAP(N1,N2)				{ N1 = N2 - N1; N2 -= N1; N1 += N2; }										///< l}N

#define SIN_TABLE_BIT			(16)																		///< TCe[ũrbg
#define SIN_TABLE_SIZE			(1 << SIN_TABLE_BIT)														///< TCe[ũTCY
#define SIN_TABLE_MASK			(SIN_TABLE_SIZE - 1)														///< TCe[ũANZXp}XN
#define ARCTAN_TABLE_SIZE		(SIN_TABLE_SIZE >> 3)														///< A[N^WFge[ũTCY
#define ARCTAN_POS_1			(ARCTAN_TABLE_SIZE << 1)													///< A[N^WFg̑Pی
#define ARCTAN_POS_2			(ARCTAN_POS_1 + ARCTAN_POS_1)												///< A[N^WFg̑Qی
#define ARCTAN_POS_3			(ARCTAN_POS_1 + ARCTAN_POS_2)												///< A[N^WFg̑Rی
#define ARCTAN_POS_4			(ARCTAN_POS_1 + ARCTAN_POS_3)												///< A[N^WFg̑Sی
#define ARCTAN_POS_SHIFT		(SIN_TABLE_BIT - 3)															///< A[N^WFg̈ʒuVtg
#define ARCTAN_SCALE(V)			(F(V) * F(1 << ARCTAN_POS_SHIFT))											///< A[N^WFg̊g嗦

#define FONT_SIZE_MAX			(128)																		///< őtHgTCY
#define TEXTURE_STAGE_MAX		(4)																			///< eNX`Xe[Wő吔
#define BONE_MAX				(32)																		///< ЂƂ̃bVŎgp\ȍő{[
#define LUNA_THREAD_MAX			(32)																		///< Xbh̍ő吔

#define NORMALIZE_ANGLE(A)		((A) & SIN_TABLE_MASK)														///< px̐Ki0`65535ցj
#define GET_ANGLE(A)			L((A) * SIN_TABLE_SIZE / 360)												///< ppx̎Zo
#define GET_ANGLE_PI(A)			L((A) * SIN_TABLE_SIZE / PI2)												///< WAppx̎Zo

#define PRIMITIVE_Z_MAX			(0xFFFF)																	///< v~eBupyől
#define INV_PRIMITIVE_Z_MAX		REV(PRIMITIVE_Z_MAX)														///< v~eBupylZopf[^
#define PRIMITIVE_Z_CENTER		F(PRIMITIVE_Z_MAX / 2)														///< v~eBuySʒu
#define Z_TO_SORT_VALUE(Z)		(L(Z) >> 3)																	///< yly\[gplZop
#define SORT_Z_MAX				Z_TO_SORT_VALUE(PRIMITIVE_Z_MAX)											///< y\[gpyől

#define MemoryClear(PD,S)		::FillMemory((PD),(S),0x00)													///< NA
#define MemoryFill(PD,PS,S)		::FillMemory((PD),(S),(PS))													///< hԂ
#define MemoryMove(PD,PS,S)		::MoveMemory((PD),(PS),(S))													///< ړ
#define MemoryCopy(PD,PS,S)		::CopyMemory((PD),(PS),(S))													///< Rs[

#define MemoryAlloc(size)		(::VirtualAlloc( NULL, ((size)+4095)&~4095, MEM_COMMIT, PAGE_READWRITE ))					///< VirtuakAllocmۃ}N
#define MemoryFree(pointer)		if ( (pointer) != NULL ) { ::VirtualFree( pointer, 0, MEM_RELEASE ); (pointer) = NULL; }	///< VirtualAlloc}N


#define CHECK_GUID(S,D)			(strcmp( (S).Data, (D) ) == 0)												///< VXeR[obNGUID`FbN

#define COLOR_BASE				(D3DCOLOR_XRGB(0xFF,0xFF,0xFF))												///< J[`F{F
#define COLOR_WHITE				(D3DCOLOR_XRGB(0xFF,0xFF,0xFF))												///< J[`F
#define COLOR_BLACK				(D3DCOLOR_XRGB(0x00,0x00,0x00))												///< J[`F
#define COLOR_RED				(D3DCOLOR_XRGB(0xFF,0x00,0x00))												///< J[`F
#define COLOR_GREEN				(D3DCOLOR_XRGB(0x00,0xFF,0x00))												///< J[`F
#define COLOR_BLUE				(D3DCOLOR_XRGB(0x00,0x00,0xFF))												///< J[`F
#define COLOR_ALPHA(A)			(D3DCOLOR_ARGB(A,0xFF,0xFF,0xFF))											///< J[`FAt@
#define COLOR_BRIGHT(B)			(D3DCOLOR_XRGB(B,B,B))														///< J[`Fx

#define LZSS_RING_LENGTH		4096																		///< obt@̑傫
#define LZSS_RING_MASK			(LZSS_RING_LENGTH-1)														///< obt@̃}XN
#define LZSS_LONGEST_MATCH		16																			///< Œv
#define NIL						LZSS_RING_LENGTH															///< ؂̖[

#define COLORKEY_DISABLE		(D3DCOLOR_ARGB(0x00,0x00,0x00,0x00))										///< eNX`ǂݍݎJ[L[sv
#define COLORKEY_BLACK			(D3DCOLOR_ARGB(0xFF,0x00,0x00,0x00))										///< eNX`ǂݍݎJ[L[ݒ
#define COLORKEY_WHITE			(D3DCOLOR_ARGB(0xFF,0xFF,0xFF,0xFF))										///< eNX`ǂݍݎJ[L[ݒ
#define COLORKEY_RED			(D3DCOLOR_ARGB(0xFF,0xFF,0x00,0x00))										///< eNX`ǂݍݎJ[L[Ԑݒ
#define COLORKEY_GREEN			(D3DCOLOR_ARGB(0xFF,0x00,0xFF,0x00))										///< eNX`ǂݍݎJ[L[ΐݒ
#define COLORKEY_BLUE			(D3DCOLOR_ARGB(0xFF,0x00,0x00,0xFF))										///< eNX`ǂݍݎJ[L[ݒ

#define LIGHT_MAX				(4)																			///< Cgő吔

#define FEP_BUFFER_SIZE			(2048)																		///< FEPpobt@

#define PADLAYER_MAX			(256)																		///< pbhpC[ő吔
#define JOYSTICK_MAX			(16)																		///< WCXeBbNő吔
#define KEY_BUFFER_MAX			(32)																		///< L[obt@pobt@TCY
#define ANIMATION_MAX			(256)																		///< Aj[Vő吔

#define WM_SOCKET				(WM_USER + 1)																///< SocketCxgMpbZ[W
#define WM_GRAPHNOTIFY			(WM_USER + 2)																///< [r[CxgMpbZ[W

#define THREAD_SYSTEM			(0xFFFFFFFF)																///< VXepXbh\萔

#define RENDER_STATE_TBL_MAX	(210)
#define TEXTURE_STATE_TBL_MAX	(33)
#define SAMPLER_STATE_TBL_MAX	(14)





//================================================================================
// OBJECT HANDLE
//================================================================================
typedef enum { INVALID_SURFACE		= -1 } LSURFACE;			///< T[tFCXnh
typedef enum { INVALID_PRIMITIVE	= -1 } LPRIMITIVE;			///< v~eBunh
typedef enum { INVALID_PRIMITIVE3D	= -1 } LPRIMITIVE3D;		///< Rcv~eBunh
typedef enum { INVALID_POINT		= -1 } LPOINT;				///< |Cgnh
typedef enum { INVALID_POINT3D		= -1 } LPOINT3D;			///< Rc|Cgnh
typedef enum { INVALID_LINE			= -1 } LLINE;				///< Cnh
typedef enum { INVALID_LINE3D		= -1 } LLINE3D;				///< RcCnh
typedef enum { INVALID_SPRITE		= -1 } LSPRITE;				///< XvCgnh
typedef enum { INVALID_SPRITE3D		= -1 } LSPRITE3D;			///< RcXvCgnh
typedef enum { INVALID_FONT			= -1 } LFONT;				///< tHgnh
typedef enum { INVALID_FONTSPRITE	= -1 } LFONTSPRITE;			///< tHgvCgnh
typedef enum { INVALID_FONTSPRITE3D	= -1 } LFONTSPRITE3D;		///< tHgvCgnh
typedef enum { INVALID_CAMERA		= -1 } LCAMERA;				///< Jnh
typedef enum { INVALID_MODEL		= -1 } LMODEL;				///< fnh
typedef enum { INVALID_ANIMATION	= -1 } LANIMATION;			///< Aj[Vnh
typedef enum { INVALID_SHEET		= -1 } LSHEET;				///< V[gnh
typedef enum { INVALID_SOUND		= -1 } LSOUND;				///< TEhnh
typedef enum { INVALID_MUSIC		= -1 } LMUSIC;				///< ~[WbNnh
typedef enum { INVALID_FIELD		= -1 } LFIELD;				///< tB[hnh
typedef enum { INVALID_MEDIA		= -1 } LMEDIA;				///< fBAnh
typedef enum { INVALID_LIST			= -1 } LLIST;				///< Xgnh


typedef enum { INVALID_SCENECONTROL	= NULL } LSCENECONTROL;		///< V[nh
typedef enum { INVALID_TEXTURE		= NULL } LTEXTURE;			///< eNX`nh
typedef enum { INVALID_MODELEX		= NULL } LMODELEX;			///< gfnh
typedef enum { INVALID_SHADERFX		= NULL } LSHADERFX;			///< GtFNgnh


//================================================================================
// ENUM
//================================================================================

/**
	@brief Xg}`

	Xg̑}̒`łB
*/
enum ePathType
{
	PATH_TYPE_ROOT,							///< [gfBNg
	PATH_TYPE_TEXTURE,						///< eNX`摜Ǎ
	PATH_TYPE_MODEL,						///< ff[^Ǎ
	PATH_TYPE_SHADER,						///< VF[_[Ǎ
	PATH_TYPE_FONT,							///< tHgf[^Ǎ
	PATH_TYPE_SOUND,						///< TEhf[^Ǎ
	PATH_TYPE_MUSIC,						///< ~[WbNf[^Ǎ
	PATH_TYPE_AUDIO,						///< I[fBIf[^Ǎ
	PATH_TYPE_MEDIA,						///< fBAf[^Ǎ
	PATH_TYPE_DATA,							///< ̑oCiǍ

	PATH_TYPE_MAX
};

/**
	@brief Xg}`

	Xg̑}̒`łB
*/
enum eListInsertPlace
{
	INSERT_TOP,							///< Xg̑Iɐڑ
	INSERT_END,							///< Xg̏I[ɐڑ
};

/**
	@brief }EX{^Ԓ`

	e{^̏Ԓ`B
*/
enum eMouseState
{
	MOUSE_FREE,							///< }EX{^͉ĂȂ
	MOUSE_PULL,							///< }EX{^͗ꂽ
	MOUSE_PUSH,							///< }EX{^͉ꂽ
	MOUSE_HOLD,							///< }EX{^͉ÂĂ
};

/**
	@brief	T[tFCXtH[}bg`

	eT[tFCXyуeNX`tH[}bg̒`B
*/
enum eSurfaceFormat
{
	FORMAT_FROM_FILE,					///< t@C

	FORMAT_DEPTH16,						///< 16Bit[xobt@
	FORMAT_DEPTH32,						///< 32Bit[xobt@
	FORMAT_DEPTHSTENCIL,				///< XeV[xobt@

	FORMAT_DXT1,						///< DXT1ktH[}bgeNX`
	FORMAT_DXT3,						///< DXT3ktH[}bgeNX`
	FORMAT_DXT5,						///< DXT5ktH[}bgeNX`

	FORMAT_BACKBUFFER,					///< obNobt@[ɏ
	FORMAT_TARGET16,					///< 16Bit_O^[Qbg
	FORMAT_TARGET32,					///< 32Bit_O^[Qbg
	FORMAT_TARGETFLOAT,					///< __O^[Qbg

	FORMAT_ALPHAONLY,					///< At@peNX`

	FORMAT_TEXTURE32,					///< 32BiteNX`tH[}bgɏ
	FORMAT_TEXTURE16,					///< 16BiteNX`tH[}bgɏ

	FORMAT_TEXTURE_2D,					///< 2DpėpeNX`tH[}bg
	FORMAT_TEXTURE_3D,					///< 3DpėpeNX`tH[}bg
};

/**
	@brief	At@ufBO[h`

	eAt@ufBO[h̒`B
*/
enum eBlendType
{
	BLEND_NONE,							///< At@uh
	BLEND_NORMAL,						///< ʏufBO
	BLEND_ADD,							///< ZufBO
	BLEND_MUL,							///< ZufBO
	BLEND_REVERSE,						///< ]ufBO
};

/**
	@brief	_tH[}bg`

	LunaSpriteNXŎgp钸_`B
*/
enum eVertexPrimitiveType
{
	PRIM_VERTEX_UV0,					///< eNX`Xe[WO̒_f[^
	PRIM_VERTEX_UV1,					///< eNX`Xe[WP̒_f[^
	PRIM_VERTEX_UV2,					///< eNX`Xe[WQ̒_f[^
	PRIM_VERTEX_UV3,					///< eNX`Xe[WR̒_f[^
	PRIM_VERTEX_UV4,					///< eNX`Xe[WS̒_f[^
};

/**
	@brief	sAc[sAڑpԒ`

	sAc[sAڑ̐ڑ󋵒`B
*/
enum ePeerStatus
{
	PEER_STATE_NOT_CONNECT,				///< ڑ
	PEER_STATE_HOSTING,					///< zXgƂĐڑ
	PEER_STATE_CONNECT,					///< NCAgƂĐڑ
};

/**
	@brief	LAG摜ptH[}bg`

	LAG摜pptH[}bg̒`B
*/
enum eLagFormat
{
	LAGFMT_A4R4G4B4,					///< 16BittH[}bg
	LAGFMT_A8R8G8B8,					///< 32BittH[}bg
	LAGFMT_A16R16G16B16,				///< 64BittH[}bg
	LAGFMT_FLOAT,						///< _^tH[}bg

	LAGFMT_COMPRESS_A4R4G4B4,			///< k16BittH[}bg
	LAGFMT_COMPRESS_A8R8G8B8,			///< k32BittH[}bg
	LAGFMT_COMPRESS_A16R16G16B16,		///< k64BittH[}bg
	LAGFMT_COMPRESS_FLOAT,				///< k_^tH[}bg
};

/**
	@brief	JOXe[^X

	r[tX^JǑʂ\`B
*/
enum eCullState
{
	CS_INSIDE,							///< oEfBO{bNX͕Iɂ̓tX^̓
	CS_OUTSIDE,							///< oEfBO{bNX̓tX^̊O
	CS_INSIDE_SLOW,						///< oEfBO{bNX̓tX^̓
	CS_OUTSIDE_SLOW,					///< oEfBO{bNX̓tX^̊O
};

/**
	@brief	RW@p̃^Cv`

	蔻̃`FbN@̒`B
*/
enum eCollisionType
{
	COLLISION_SPHERE,					///< 蔻ōs
	COLLISION_AABB,						///< 蔻AABBōs
	COLLISION_OBB,						///< 蔻OBBōs
};

/**
	@brief	POVpx萔
*/
enum ePOV
{
	POV_0		= 0,
	POV_45		= 45,
	POV_90		= 90,
	POV_135		= 135,
	POV_180		= 180,
	POV_225		= 225,
	POV_270		= 270,
	POV_315		= 315,
	POV_N		= POV_0,
	POV_NE		= POV_45,
	POV_E		= POV_90,
	POV_SE		= POV_135,
	POV_S		= POV_180,
	POV_SW		= POV_225,
	POV_W		= POV_270,
	POV_NW		= POV_315,
};

/**
	@brief	L[Xe[^X`

	LunaPadNXŎgpL[̊eԒ`B
*/
enum eKeyState
{
	KEY_STATE_FREE,						///< L[̓t[
	KEY_STATE_PULL,						///< L[͗ꂽu
	KEY_STATE_PUSH,						///< L[͉ꂽu
	KEY_STATE_HOLD,						///< L[͉ꑱĂ
};

/**
	@brief	pbhXe[g`

	LunaPadNXŎgppbh̊eԒ`B
*/
enum ePadState
{
	PAD_STATE_PUSH,						///< uԎ擾p
	PAD_STATE_PULL,						///< uԎ擾p
	PAD_STATE_HOLD,						///< 擾p
	PAD_STATE_REPEAT,					///< s[g擾p

	PAD_STATE_MAX,
};

/**
	@brief	pbhpe{^`

	LunaPadNXŎgpe{^̒`B
*/
enum ePadSort
{
	PAD_DIR_UP,							///< w
	PAD_DIR_DOWN,						///< w
	PAD_DIR_LEFT,						///< w
	PAD_DIR_RIGHT,						///< Ew

	PAD_BUTTON_01,						///< {^Pw
	PAD_BUTTON_02,						///< {^Qw
	PAD_BUTTON_03,						///< {^Rw
	PAD_BUTTON_04,						///< {^Sw
	PAD_BUTTON_05,						///< {^Tw
	PAD_BUTTON_06,						///< {^Uw
	PAD_BUTTON_07,						///< {^Vw
	PAD_BUTTON_08,						///< {^Ww
	PAD_BUTTON_09,						///< {^Xw
	PAD_BUTTON_10,						///< {^POw
	PAD_BUTTON_11,						///< {^PPw
	PAD_BUTTON_12,						///< {^PQw
	PAD_BUTTON_13,						///< {^PRw
	PAD_BUTTON_14,						///< {^PSw
	PAD_BUTTON_15,						///< {^PTw
	PAD_BUTTON_16,						///< {^PUw

	PAD_SORT_MAX,

	PAD_SORT_NONE,						///< 
};

/**
	@brief	Cg^Cv`

	Cg̎ޒ`B
*/
enum eLightType
{
	LIGHT_DIRECTION,					///< sCg
	LIGHT_POINT,						///< _Cg
};

/**
	@brief	Aj[V^Cv`

	LunaAnimationNXŎgpAj[V̕@\`B
*/
enum eAnimationType
{
	ANIM_TYPE_STEP,						///< Xebv
	ANIM_TYPE_LINEAR,					///< `
	ANIM_TYPE_NEWTON,					///< j[g
	ANIM_TYPE_TCB,						///< sbaXvC
};

/**
	@brief	t@CV[N`

	LunaFileNXŎgpt@CV[N̕@\`B
*/
enum eSeekFlag
{
	SEEK_FILE_CURRENT,					///< Jgʒu
	SEEK_FILE_START,					///< 擪ʒu
	SEEK_FILE_END,						///< I[ʒu
};


//================================================================================
// STRUCTURE
//================================================================================

/**
	@brief	_f[^

	LunaŎgp_\p̍\́B
*/
struct LUNAPOINT
{
	Float Px;					///< wW
	Float Py;					///< xW

	/**
		@brief lݒ
		lȗIɐݒ肷邽߂̊֐B

		@param px		[in] wW
		@param py		[in] xW
	*/
	void Set( Float px, Float py )
	{
		Px = px;
		Py = py;
	}
};

/**
	@brief	`f[^

	LunaŎgp`\p̍\́B
*/
struct LUNARECT
{
	Float Px;					///< wn_W
	Float Py;					///< xn_W
	Float Sx;					///< wTCY
	Float Sy;					///< xTCY

	/**
		@brief lݒ
		lȗIɐݒ肷邽߂̊֐B

		@param px		[in] wn_W
		@param py		[in] xn_W
		@param sx		[in] wTCY
		@param sy		[in] xTCY
	*/
	void Set( Float px, Float py, Float sx, Float sy )
	{
		Px = px;
		Py = py;
		Sx = sx;
		Sy = sy;
	}
};

/**
	@brief	NbsÖ

	NbsOp̋`f[^
*/
struct CLIPRECT
{
	Sint32 x1;					///< wʒun_
	Sint32 y1;					///< xʒun_
	Sint32 x2;					///< wʒuI_
	Sint32 y2;					///< xʒuI_
};

/**
	@brief	tHg``

	tHg`p̃NbsO`p`f[^
*/
struct FONTDRAWRECT
{
	Sint32 x1;					///< wn_W
	Sint32 y1;					///< xn_W
	Sint32 x2;					///< wI_W
	Sint32 y2;					///< xI_W
	Sint32 Pitch;					///< tHg摜̃sb`
	void *pBits;				///< tHg̃sNZf[^̐擪|C^
};

/**
	@brief	kf[^wb_

	LunaCompresNXŎgpAkf[^̃wb_B
*/
struct LZSSHEADER
{
	char Chunk[4];							///< p̃t@Cł邱Ƃ߂ʎqB'L''Z''S''S'
	Uint32 DecodeSize;				///< WJ̃f[^TCY
	Uint32 Reserved[2];				///< \̈iɂOj
};

/**
	@brief	16BitsNZf[^

	16BitsNZtH[}bg̍\́B
*/
struct PIXELDATA16
{
	Uint16 a : 4;				///< At@
	Uint16 r : 4;				///< Ԑ
	Uint16 g : 4;				///< ΐ
	Uint16 b : 4;				///< 
};

/**
	@brief	32BitsNZf[^

	32BitsNZtH[}bg̍\́B
*/
struct PIXELDATA32
{
	Uint8 b;				///< 
	Uint8 g;				///< ΐ
	Uint8 r;				///< Ԑ
	Uint8 a;				///< At@
};

/**
	@brief	64BitsNZf[^

	64BitsNZtH[}bg̍\́B
*/
struct PIXELDATA64
{
	Uint16 b;				///< 
	Uint16 g;				///< ΐ
	Uint16 r;				///< Ԑ
	Uint16 a;				///< At@
};

/**
	@brief	Float^sNZf[^

	_sNZtH[}bg̍\́B
*/
struct PIXELDATAFLOAT
{
	Float b;						///< 
	Float g;						///< ΐ
	Float r;						///< Ԑ
	Float a;						///< At@
};


/**
	@brief	Qc|S

	ʏ̃VvȂQc`sɎgp钸_f[^\́B
*/
struct VERTEX2D
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	Float w;							///< vʒu
	D3DCOLOR c;							///< _F
	Float u;							///< tu
	Float v;							///< tu

	/**
		VERTEX2D_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)
	};
};

/**
	@brief	v~eBu_

	eNX`tuSXe[W܂񂾃v~eBup_
*/
struct PRIMVERTEX0
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	Float w;							///< vʒu
	D3DCOLOR c;							///< _F

	/**
		PRIMVERTEX0_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZRHW | D3DFVF_DIFFUSE)
	};
};


/**
	@brief	v~eBu_

	eNX`tuPXe[W܂񂾃v~eBup_
*/
struct PRIMVERTEX1
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	Float w;							///< vʒu
	D3DCOLOR c;							///< _F
	Float u1;							///< tuXe[WP
	Float v1;							///< tuXe[WP

	/**
		PRIMVERTEX1_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX1)
	};
};

/**
	@brief	v~eBu_

	eNX`tuQXe[W܂񂾃v~eBup_
*/
struct PRIMVERTEX2
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	Float w;							///< vʒu
	D3DCOLOR c;							///< _F
	Float u1;							///< tuXe[WP
	Float v1;							///< tuXe[WP
	Float u2;							///< tuXe[WQ
	Float v2;							///< tuXe[WQ

	/**
		PRIMVERTEX2_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX2)
	};
};

/**
	@brief	v~eBu_

	eNX`tuRXe[W܂񂾃v~eBup_
*/
struct PRIMVERTEX3
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	Float w;							///< vʒu
	D3DCOLOR c;							///< _F
	Float u1;							///< tuXe[WP
	Float v1;							///< tuXe[WP
	Float u2;							///< tuXe[WQ
	Float v2;							///< tuXe[WQ
	Float u3;							///< tuXe[WR
	Float v3;							///< tuXe[WR

	/**
		PRIMVERTEX3_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX3)
	};
};

/**
	@brief	v~eBu_

	eNX`tuSXe[W܂񂾃v~eBup_
*/
struct PRIMVERTEX4
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	Float w;							///< vʒu
	D3DCOLOR c;							///< _F
	Float u1;							///< tuXe[WP
	Float v1;							///< tuXe[WP
	Float u2;							///< tuXe[WQ
	Float v2;							///< tuXe[WQ
	Float u3;							///< tuXe[WR
	Float v3;							///< tuXe[WR
	Float u4;							///< tuXe[WS
	Float v4;							///< tuXe[WS

	/**
		PRIMVERTEX4_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZRHW | D3DFVF_DIFFUSE | D3DFVF_TEX4)
	};
};

/**
	@brief	Rcv~eBu_

	eNX`tu܂܂ȂRcv~eBup_
*/
struct PRIMVERTEX3D0
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	D3DCOLOR c;							///< _F

	/**
		PRIMVERTEX3D0_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZ | D3DFVF_DIFFUSE)
	};
};

/**
	@brief	Rcv~eBu_

	eNX`tuPXe[W܂񂾂Rcv~eBup_
*/
struct PRIMVERTEX3D1
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	D3DCOLOR c;							///< _F
	Float u1;							///< tuXe[WP
	Float v1;							///< tuXe[WP

	/**
		PRIMVERTEX3D1_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1)
	};
};

/**
	@brief	Rcv~eBu_

	eNX`tuQXe[W܂񂾂Rcv~eBup_
*/
struct PRIMVERTEX3D2
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	D3DCOLOR c;							///< _F
	Float u1;							///< tuXe[WP
	Float v1;							///< tuXe[WP
	Float u2;							///< tuXe[WQ
	Float v2;							///< tuXe[WQ

	/**
		PRIMVERTEX3D2_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX2)
	};
};

/**
	@brief	Rcv~eBu_

	eNX`tuRXe[W܂񂾂Rcv~eBup_
*/
struct PRIMVERTEX3D3
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	D3DCOLOR c;							///< _F
	Float u1;							///< tuXe[WP
	Float v1;							///< tuXe[WP
	Float u2;							///< tuXe[WQ
	Float v2;							///< tuXe[WQ
	Float u3;							///< tuXe[WR
	Float v3;							///< tuXe[WR

	/**
		PRIMVERTEX3D3_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX3)
	};
};

/**
	@brief	Rcv~eBu_

	eNX`tuSXe[W܂񂾂Rcv~eBup_
*/
struct PRIMVERTEX3D4
{
	Float x;							///< wʒu
	Float y;							///< xʒu
	Float z;							///< yʒu
	D3DCOLOR c;							///< _F
	Float u1;							///< tuXe[WP
	Float v1;							///< tuXe[WP
	Float u2;							///< tuXe[WQ
	Float v2;							///< tuXe[WQ
	Float u3;							///< tuXe[WR
	Float v3;							///< tuXe[WR
	Float u4;							///< tuXe[WS
	Float v4;							///< tuXe[WS

	/**
		PRIMVERTEX3D4_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX4)
	};
};

/**
	@brief	VF[_[p

	VF[_[IƂɎgpf[^\́B
*/
struct SHADERCREATE
{
	Uint32 BoneWeightCount;		///< {[EFCg
	Uint32 ShaderVersion;		///< VF[_[o[W
	bool IsSoftwareVP;					///< \tgEFAۂ
};

/**
	@brief	}EXf[^

	}EXf[^i[邽߂̍\́B
*/
struct MOUSEDATA
{
	Sint32 X;								///< wʒu
	Sint32 Y;								///< xʒu
	Sint32 W;								///< yʒu
	bool ClickL;						///< NbN
	bool ClickR;						///< ENbN
	bool ClickW;						///< zC[NbN
	bool DoubleClickL;					///< E_uNbN
	bool DoubleClickR;					///< _uNbN
	bool DoubleClickW;					///< zC[_uNbN

	eMouseState StateL;					///< {^
	eMouseState StateR;					///< E{^
	eMouseState StateW;					///< zC[{^
};

/**
	@brief	L[{[hf[^

	L[{[hf[^M邽߂̍\
*/
struct KEYBOARDDATA
{
	char Key[256];						///< 
};

/**
	@brief	WCXeBbNf[^

	WCXeBbNpf[^i[Ă߂̍\́B
*/
struct JOYSTICKDATA
{
	Sint32 Px, Py, Pz;					///< 
	Sint32 Rx, Ry, Rz;					///< ]
	Sint32 Vx, Vy, Vz;					///< ̑x
	Sint32 VRx, VRy, VRz;				///< ̊px
	Sint32 Ax, Ay, Az;					///< ̉x
	Sint32 ARx, ARy, ARz;				///< ̊px
	Sint32 Fx, Fy, Fz;					///< ̃tH[X
	Sint32 FRx, FRy, FRz;				///< ̃gN
	Sint32 Slider[2];					///< XC_[
	Sint32 Pov[4];						///< POV
	char Button[16];					///< {^
};


/**
	@brief	Q̓_

	LunaCollisionNXŎg_f[^\́B
*/
struct POINT2D
{
	Float Px;							///< wʒu
	Float Py;							///< xʒu
};

/**
	@brief	Q̉~

	LunaCollisionNXŎg~f[^\́B
*/
struct CIRCLE2D
{
	POINT2D Center;						///< ~̒S
	Float Radius;						///< ~̔a
};

/**
	@brief	Q̎lp

	LunaCollisionNXŎglp`f[^\́B
*/
struct RECT2D
{
	Float Sx;							///< wW
	Float Sy;							///< xW
	Float Ex;							///< EwW
	Float Ey;							///< ExW
};

/**
	@brief	Q̑p`

	LunaCollisionNXŎg鑽p`f[^\́B
*/
struct POLYGON2D
{
	Sint32 Count;							///< |Cgz̃|Cg
	POINT2D *pPts;						///< |S\߂̃|Cgz̃|C^
};

/**
	@brief	Q̐

	LunaCollisionNXŎgf[^\́B
*/
struct LINE2D
{
	POINT2D Pt0;						///< n_ʒu
	POINT2D Pt1;						///< I_ʒu
};

/**
	@brief	R̓_
*/
struct POINT3D
{
	Float Px;							///< wʒu
	Float Py;							///< xʒu
	Float Pz;							///< yʒu

	POINT3D(){}														///< RgN^
	POINT3D( Float x, Float y, Float z ){ Px = x; Py = y; Pz = z; }	///< RgN^
	POINT3D( POINT3D &pt ) { Px = pt.Px; Py = pt.Py; Pz = pt.Pz; }	///< RgN^
};

/**
	@brief	R̉~i

	LunaCollisionNXŎgp鋅f[^\́B
*/
struct SPHERE3D
{
	POINT3D Center;						///< ̒S
	Float Radius;						///< ̔a

	SPHERE3D(){}															///< RXgN^
	SPHERE3D( POINT3D &pt, Float radius ){ Center = pt; Radius = radius; }	///< RXgN^
};

/**
	@brief	R̐

	LunaCollisionNXŎgf[^\́B
*/
struct LINE3D
{
	POINT3D Pt0;						///< n_ʒu
	POINT3D Pt1;						///< I_ʒu

	LINE3D(){}																///< RXgN^
	LINE3D( POINT3D &pt0, POINT3D &pt1 ) { Pt0 = pt0; Pt1 = pt1; }			///< RXgN^
};

/**
	@brief	R̖

	LunaCollisionNXŎgʃf[^\́B
*/
struct PLANE3D
{
	Float a;							///< ʕʕɂNbvʂ a W 
	Float b;							///< ʕʕɂNbvʂ b W 
	Float c;							///< ʕʕɂNbvʂ c W 
	Float d;							///< ʕʕɂNbvʂ d W 
};

/**
	@brief	R̔

	LunaCollisionNXŎg锠f[^\́B
*/
struct BOX3D
{
	POINT3D Points[8];					///< ̊ep\_f[^
	PLANE3D Planes[6];					///< ̊eʂ\ʃf[^
};

/**
	@brief	VF[_[pCgf[^

    VF[_[p̃CeBOf[^
	i[邽߂̍\́B
*/
struct SHADERLIGHTDATA
{
	BOOL IsActive[LIGHT_MAX];			///< Cggp邩ۂ
	BOOL IsDirection[LIGHT_MAX];		///< fBNViCgۂ
	Float Attenuation[LIGHT_MAX];		///< Cg
	D3DXVECTOR4 Position[LIGHT_MAX];	///< Cgʒu
	D3DXVECTOR4 Direction[LIGHT_MAX];	///< Cg
	D3DCOLORVALUE Color[LIGHT_MAX];		///< CgF
	D3DCOLORVALUE Specular;				///< ˌ
	D3DCOLORVALUE Ambient;				///< 
};

/**
	@brief	fp_

	{[_x[X_\́B<BR>
	Œ@\ŏ\ȃ{[_`̍\́B
*/
struct BASEVERTEX
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu

	/**
		BASEVERTEX_peue`
	*/
	enum {
		/// euetH[}bg`
		FVF = (D3DFVF_XYZ | D3DFVF_NORMAL | D3DFVF_DIFFUSE | D3DFVF_TEX1)
	};
};



/**
	@brief	Sf[^ۗL_

	S_f[^ۗLp_f[^\́B
	ǂݍ܂ꂽf[f[^͕Ǩ`
	_f[^ۗLĂ܂B
*/
struct VERTEXALL
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	D3DXVECTOR3 PosMorph;				///< ^[Qbg_
	D3DXVECTOR3 NormMorph;				///< ^[Qbg@
	Float Weight[3];					///< EFCg
	Uint8 Index[4];				///< {[CfbNX
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu
};

/**
	@brief	ʏ풸_

	ʏ̓ϊp̒_\́B
*/
struct VERTEXNORMAL
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu
};

/**
	@brief	[tBOp_

	[tBO\Ȓ_̍\́B
*/
struct VERTEXMORPH
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	D3DXVECTOR3 PosMorph;				///< ^[Qbgʒu
	D3DXVECTOR3 NormMorph;				///< ^[Qbg@
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu
};

/**
	@brief	{[QEFCg_

	őQ{̃{[̉e󂯂钸_̍\́B
*/
struct VERTEXBONE2
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	Float Weight[1];					///< EFCg
	Uint8 Index[4];				///< {[CfbNX
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu
};

/**
	@brief	{[REFCg_

	őR{̃{[̉e󂯂钸_̍\́B
*/
struct VERTEXBONE3
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	Float Weight[2];					///< EFCg
	Uint8 Index[4];				///< {[CfbNX
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu 
};

/**
	@brief	{[SEFCg_

	őS{̃{[̉e󂯂钸_̍\́B
*/
struct VERTEXBONE4
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	Float Weight[3];					///< EFCg
	Uint8 Index[4];				///< {[CfbNX
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu
};

/**
	@brief	{[QEFCg[tBO_

	őQ{̃{[̉e󂯂郂[tBOL蒸_̍\́B
*/
struct VERTEXBONE2MORPH
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	D3DXVECTOR3 PosMorph;				///< ^[Qbg_
	D3DXVECTOR3 NormMorph;				///< ^[Qbg@
	Float Weight[1];					///< EFCg
	Uint8 Index[4];				///< {[CfbNX
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu
};

/**
	@brief	{[REFCg[tBO_

	őR{̃{[̉e󂯂郂[tBOL蒸_̍\́B
*/
struct VERTEXBONE3MORPH
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	D3DXVECTOR3 PosMorph;				///< ^[Qbg_
	D3DXVECTOR3 NormMorph;				///< ^[Qbg@
	Float Weight[2];					///< EFCg
	Uint8 Index[4];				///< {[CfbNX
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu
};

/**
	@brief	{[SEFCg[tBO_

	őS{̃{[̉e󂯂郂[tBOL蒸_̍\́B
*/
struct VERTEXBONE4MORPH
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	D3DXVECTOR3 PosMorph;				///< ^[Qbg_
	D3DXVECTOR3 NormMorph;				///< ^[Qbg@
	Float Weight[3];					///< EFCg
	Uint8 Index[4];				///< {[CfbNX
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu
};

/**
	@brief	ov}bvp_

	ov}bv̓ϊp̒_\́B
*/
struct VERTEXBUMPMAP
{
	D3DXVECTOR3 Pos;					///< ʒu
	D3DXVECTOR3 Norm;					///< @
	D3DXVECTOR3 Tangent;				///< ڐ
	D3DXVECTOR3 BiNorm;					///< ]@
	D3DCOLOR Color;						///< _F
	D3DXVECTOR2 Tex;					///< eNX`tu
};

/**
	@brief	zXg

	\PbggpɃzXgi[邽߂Ɏg\́B
*/
struct HOSTINFO
{
	char Name[256];						///< zXg
	char Alias[16][256];				///< zXgʖe[u
	char Address[16][64];				///< IPAhXe[u
	Sint32 Type;						///< f[^^Cv
	Sint32 Length;						///< f[^TCY
	Sint32 AliasCount;					///< GCAX
	Sint32 AddressCount;				///< IPAhX
};

/**
	@brief	\PbgpMf[^`

	\PbggpɃf[^𑗐MۂɎgpf[^\́B
*/
struct SOCKETSENDDATA
{
	Uint32 Send;					///< Mς݃f[^TCY
	Uint32 Size;					///< MvTCY
	Uint8 *pData;					///< Mf[^
};



//=============================================================================
// WORK ENUM
//=============================================================================

/**
	@brief	R[h`

	LunaFontSpriteNXŎgp<BR>
	S-JISR[h\̃CfbNXZop`ł
*/
enum
{
	CODE_ASCII_START		= 0x0000,
	CODE_ASCII_END			= 0x00FF,

	CODE_SJIS_A_START		= 0x8140,
	CODE_SJIS_A_END			= 0x9FFF,

	CODE_SJIS_B_START		= 0xE040,
	CODE_SJIS_B_END			= 0xEEFF,

	CODE_SJIS_C_START		= 0xF8A0,
	CODE_SJIS_C_END			= 0xFC4F,

	CODE_TABLE_SIZE			= (CODE_ASCII_END - CODE_ASCII_START) + (CODE_SJIS_A_END - CODE_SJIS_A_START) + (CODE_SJIS_B_END - CODE_SJIS_B_START) + (CODE_SJIS_C_END - CODE_SJIS_C_START),	///< ŏIIȃe[uTCY

	SHEET_MAX				= 32,		///< LunaFontSpriteNXŎgpV[gő吔
};

/**
	@brief	V[gTCY`

	LunaSheetNXŎgpV[g̊e`ł
*/
enum {
	SHEET_X_MAX		= 16,			///< w̃V[gő吔
	SHEET_Y_MAX		= 16,			///< x̃V[gő吔

	SHEET_SIZE_X	= 256,			///< V[ĝwőTCY
	SHEET_SIZE_Y	= 256,			///< V[ĝxőTCY
};

/**
	@brief	GtFNgp[^[nh`

	LunaModelExNXŎgpGtFNgnh̊e`ł
*/
enum {
	FX_HANDLE_mTransform,			///< ϊps
	FX_HANDLE_mWorld,				///< [hϊs
	FX_HANDLE_mWorldView,			///< JԂւ̕ϊs

	FX_HANDLE_mBoneMatrixArray,		///< {[ps
	FX_HANDLE_BoneWeightCount,		///< {[EFCg

	FX_HANDLE_LightIsUse,			///< CgFgpLtO
	FX_HANDLE_LightIsDirectional,	///< CgFstOitrue:s/false:_j
	FX_HANDLE_LightAttenuation,		///< CgFX|bgCg
	FX_HANDLE_LightColor,			///< CgFF
	FX_HANDLE_LightParameter,		///< CgForʒuiʒuLightIsDirectionalɈˑj

	FX_HANDLE_MaterialDiffuse,		///< }eAFfBt[Y
	FX_HANDLE_MaterialAmbient,		///< }eAFArGg

	FX_HANDLE_vCameraPos,			///< Jʒu
	FX_HANDLE_SlideTextureU,		///< eNX`tXChl
	FX_HANDLE_SlideTextureV,		///< eNX`uXChl
	FX_HANDLE_VertexExtrusion,		///< _ol
	FX_HANDLE_MorphWeight,			///< [tBOEFCg

	FX_HANDLE_FogParameter,			///< tHOFvZp
	FX_HANDLE_FogTransform,			///< tHOFylZop

	FX_HANDLE_TextureStage0,		///< eNX`FXe[WO
	FX_HANDLE_TextureStage1,		///< eNX`FXe[WP
	FX_HANDLE_TextureStage2,		///< eNX`FXe[WQ
	FX_HANDLE_TextureStage3,		///< eNX`FXe[WR

	FX_HANDLE_MAX,
};

/**
	@brief	_^Cv`

	LunaModelExŎgp钸_tH[}bg`B
*/
enum eVertexType
{
	VX_NORMAL,						///< ʏ̓ϊp
	VX_MORPH,						///< [tBOL蓧ϊp
	VX_BONE2,						///< Q{[e{[ϊ
	VX_BONE3,						///< R{[e{[ϊ
	VX_BONE4,						///< S{[e{[ϊ
	VX_BONE2MORPH,					///< Q{[e{[ϊ{[tBO
	VX_BONE3MORPH,					///< R{[e{[ϊ{[tBO
	VX_BONE4MORPH,					///< S{[e{[ϊ{[tBO

	VX_UNKNOW,
};


//=============================================================================
// WORK STRUCT
//=============================================================================

/**
	@brief	LFDt@Cwb_

	LFDt@Cp̃t@Cwb_\́B
*/
struct LFDHEADER
{
	char Guid[4];								///< t@Cʏi 'L' 'F' 'D' '\0'
	Uint8 FontSize;						///< tHgTCY
	Uint8 SheetMax;						///< V[gő吔
	Uint16 SheetWidth;					///< V[g
	Uint16 SheetHeight;					///< V[gc
	Uint16 FontMax;						///< tHgő吔
	Uint16 IndexTbl[CODE_TABLE_SIZE];	///< CfbNXe[u
};

/**
	@brief	{IuWFNg

	eIuWFNg̊{ƂȂ\̂ł
*/
struct OBJECTBASE
{
	bool IsUse;							///< gptO
	Uint32 RefCount;					///< QƃJE^
};

/**
	@brief	{IuWFNgt@C

	et@CIuWFNg̊{ƂȂ\̂ł
*/
struct OBJECTFILE : public OBJECTBASE
{
	char FileName[MAX_PATH];				///< t@C
};

/**
	@brief	tHgV[gf[^

	tHgV[g̊etHg̃f[^i[\̂ł
*/
struct FONTSHEETDATA
{
	Uint8 SheetNo;		///< V[gԍ
	Uint8 abcA;			///< ABC
	Uint8 abcB;			///< ABC
	Uint8 abcC;			///< ABC
	Uint16 x1;			///< UVf[^
	Uint16 y1;			///< UVf[^
	Uint16 x2;			///< UVf[^
	Uint16 y2;			///< UVf[^
};



/**
	@brief	eNX`V[g

	LunaSheetNXŎgpAeNX`V[g<BR>
	i[邽߂̍\̂ł
*/
struct TEXTURESHEET
{
	Sint32 Px;								///< wʒu
	Sint32 Py;								///< xʒu
	Sint32 Sx;								///< wTCY
	Sint32 Sy;								///< xTCY
	LTEXTURE lTex;							///< eNX`nh
	VERTEX2D Vx[4];							///< _f[^
};

/**
	@brief	V[gf[^

	LunaSheetNXŎgpAeNX`V[g<BR>
	Ǘ邽߂̍\̂ł
*/
struct SHEETDATA : public OBJECTFILE
{
	TEXTURESHEET **ppSheets;				///< V[gf[^|C^
	Sint32 CountX;							///< wV[g
	Sint32 CountY;							///< xV[g
	Sint32 Width;								///< w
	Sint32 Height;							///< x
};

/**
	@brief	LZSSf[^wb_

	LZSS̃f[^i[邽߂̃wb_
*/
struct LZSS_HEADER
{
	char Guid[4];				///< 'L' 'Z' 'S' 'S'
	Uint32 OriginalSize;	///< IWĩt@CTCY
};

/**
	@brief	tHgf[^

	LunaFontNXŎgpAtHgf[^<BR>
	Ǘ邽߂̍\̂ł
*/
struct FONTDATA : public OBJECTBASE
{
	HDC hDC;								///< foCXReLXgnh
	HFONT hFont;							///< tHgnh
	HFONT hOldFont;							///< ÕtHgnh
	TEXTMETRIC TextMetric;					///< tHggbN
	char *pBuffer;							///< obt@|C^
	Sint32 FontSize;						///< tHgTCY
	LTEXTURE lTarget;						///< ^[Qbgnh
	bool IsAlpha;							///< At@`lLtO
	bool IsUpdate;							///< `ɃeNX`XV邩ǂ
};


/**
	@brief	CDgbNf[^

	LunaCDDANXŎgpACDgbNf[^<BR>
	Ǘ邽߂̍\̂ł
*/
struct TRACKDATA
{
	Uint32 TrackStart;				///< gbNJnʒu
	Uint32 TrackLength;				///< gbNIʒu
};


/**
	@brief	Xgpwb_
*/
struct LISTHEADER
{
	LLIST lList;
	Sint32 RefCount;
	LISTHEADER *pPrev;
	LISTHEADER *pNext;
	void (*pCallback)( void *pData );
};

/**
	@brief	Xgpwb_
*/
struct LISTDATA
{
	bool IsUse;
	Sint32 Count;
	LISTHEADER *pTop;
	LISTHEADER *pEnd;
};

/**
	@brief	T[tFCXpfoCXXe[g
*/
struct MATERIALSTATE
{
	Uint32				SamplerState[TEXTURE_STAGE_MAX][SAMPLER_STATE_TBL_MAX];
	Uint32				TextureState[TEXTURE_STAGE_MAX][TEXTURE_STATE_TBL_MAX];
	eBlendType		BlendType;
	bool				IsColorKey;
	bool				IsBilinear;
	bool				IsZBuffer;
	bool				IsZWrite;
};

}//eon

#endif // ___LUNABASE_H___

